// I2C_climate_station.ino

#include "TwoWireLCD.h"
#include <Wire.h>
#include <Adafruit_BMP085.h>

Adafruit_BMP085 bmp;

#define LM75_1 0b1001000   // LM75 #I 7-bit adresse
#define LM75_2 0b1001011   // LM75 #II 7-bit adresse

float P, T1, T2, T3;

void setup()
{ // Initialize I2C and I2C-LCD-Moduls
  Wire.begin();
  LCD.begin();
  Serial.begin(115200);
  
  while (!Serial) {}
  Serial.println(F("Init I2C"));
  // Initialisierung des Sensors
  if (!bmp.begin()) 
  { Serial.println("No BMP085 sensor found!");
    while (1) {}
  }
}

void loop()
{ byte msb_1,lsb_1=0, msb_2,lsb_2=0;
  float Degrees_1=0, Degrees_2=0;
  
  // read LM75_1    
    Wire.beginTransmission(LM75_1);
    Wire.write((byte)0x00);
    Wire.endTransmission();
  
    Wire.requestFrom(LM75_1, 2);       
    while(Wire.available() < 2);     
    msb_1 = Wire.read();     
    lsb_1 = Wire.read();

    if(msb_1 < 0x80)
    { Degrees_1=((msb_1*10)+(((lsb_1&0x80)>>7)*5));
    }
    else
    { Degrees_1=((msb_1*10)+(((lsb_1&0x80)>>7)*5));
      Degrees_1=-(2555.0-Degrees_1);
    }
    Degrees_1=Degrees_1/10;

 // read LM75_2    
    Wire.beginTransmission(LM75_2);
    Wire.write((byte)0x00);
    Wire.endTransmission();
  
    Wire.requestFrom(LM75_2, 2);       
    while(Wire.available() < 2);     
    msb_2 = Wire.read();     
    lsb_2 = Wire.read();

    if(msb_2 < 0x80)
    { Degrees_2=((msb_2*10)+(((lsb_2&0x80)>>7)*5));
    }
    else
    { Degrees_2=((msb_2*10)+(((lsb_2&0x80)>>7)*5));
      Degrees_2=-(2555.0-Degrees_2);
    }
    Degrees_2=Degrees_2/10;
    
  
  P = bmp.readPressure();
  T1 = bmp.readTemperature();
  T2 = Degrees_1;
  T3 = Degrees_2;
  
  Serial.println(P);  Serial.println(T1);
  Serial.println(T2);  Serial.println(T3);
   
  // show preassure P in display
  LCD.setLeds(~1);
  if (P < 1e5) LCD.print(P/10, NO_LEADING_ZEROS, 1);
  else LCD.print(P/100, NO_LEADING_ZEROS, 0);
  LCD.update(); delay(3000);  
  LCD.clearSegments();
  
  // show temperature T1 in display
  LCD.setLeds(~2);
  LCD.print(10*T1, NO_LEADING_ZEROS, 1);
  LCD.showDegree(1);  
  LCD.update(); delay(3000);  
  LCD.clearSegments();  LCD.showDegree(0);  

// show temperature T2 in display
  LCD.setLeds(~4);
  LCD.print(10*T2, NO_LEADING_ZEROS, 1);
  LCD.showDegree(1);  
  LCD.update(); delay(3000);  
  LCD.clearSegments();  LCD.showDegree(0);  

  // show temperature T3 in display
  LCD.setLeds(~8);
  LCD.print(10*T3, NO_LEADING_ZEROS, 1);
  LCD.showDegree(1);  
  LCD.update(); delay(3000);  
  LCD.clearSegments();  LCD.showDegree(0);  
}


